type t = (string * int);;

let length (_, i) = i;;

let of_bools l = (Hashlib.bools_to_bitlist_rev l, List.length l);;
let to_bools (s, l) = Hashlib.bitlist_to_bools_rev s l;;

let cut_prefix (s, i) j =
  if j > i || i < 0 then failwith "Bitlist.cut_prefix cannot extend"
  else (s, i - j);;

let nth (s,l) i =
  Hashlib.nth_bit s (l - i - 1);;

let hd b = nth b 0;;
let tl (s, n) = (s, n - 1);;

let cons b (s, n) = (Hashlib.bools_to_bitlist_revappend [b] s n, n + 1);;
let rev_append l (s, n) = (Hashlib.bools_to_bitlist_revappend l s n, n + List.length l);;

let to_string (s, _) = s;;
let of_string s = (Hashlib.rev s, String.length s * 8);;

let print b = String.concat "" (List.map (fun b -> if b then "1" else "0") (to_bools b));;
