(* Big endian strings of bits, internally stored as sequences of characters *)
external int32_bebits   : int32 -> string = "c_int32_bebits";;
external int32p5_bebits : int32 * int32 * int32 * int32 * int32 -> string = "c_int32pow5_bebits";;
external int32p8_bebits : int32 * int32 * int32 * int32 * int32 * int32 * int32 * int32 -> string = "c_int32pow8_bebits";;

external bebits_int32   : string -> int32 = "c_bebits_int32";;
external bebits_int32p5 : string -> int32 * int32 * int32 * int32 * int32 = "c_bebits_int32pow5";;
external bebits_int32p8 : string -> int32 * int32 * int32 * int32 * int32 * int32 * int32 * int32 = "c_bebits_int32pow8";;

external bebits_hexstring : string -> string = "c_bebits_hexstring";;
(* If length odd, last character is ignored as we cannot put it in a single be character *)
external hexstring_bebits : string -> string = "c_hexstring_bebits";;
external rev : string -> string = "c_rev";;

let hashval_hexstring : int32 * int32 * int32 * int32 * int32 * int32 * int32 * int32 -> string =
  fun x -> bebits_hexstring (int32p8_bebits x);;

external nth_bit : string -> int -> bool = "c_nth_bit";;
external bools_to_bitlist : bool list -> string = "c_bools_to_bitlist";;
external bools_to_bitlist_rev : bool list -> string = "c_bools_to_bitlist_rev";;
external bitlist_to_bools : string -> int -> bool list = "c_bitlist_to_bools";;
external bitlist_to_bools_rev : string -> int -> bool list = "c_bitlist_to_bools_rev";;

external bools_to_bitlist_revappend : bool list -> string -> int -> string = "c_bools_to_bitlist_revappend";;
